import time

from netforce.model import get_model
from netforce import migration
from netforce.access import set_active_user, set_active_company

class Migration(migration.Migration):
    _name="clinic.rename.dbl.hdcase.number"
    _version="2.12.2"
    
    def migrate(self):
        set_active_company(1)
        set_active_user(1)
        datenow=time.strftime("%Y-%m-%d")
        dom=[
            ['date','>=',datenow],
            ['date','<=',datenow],
        ]
        for hdcase in get_model("clinic.hd.case").search_browse(dom):
            nums=hdcase.number.split("-")
            if len(nums)==3 and len(nums[1])==4:
                run=nums[1]
                number='-'.join([nums[0],run[0:2],run[2:],nums[2]])
                print('XXX', hdcase.number, ' --> ', number)
                hdcase.write({
                    'number': number,
                })

Migration.register()
