from netforce.model import Model, fields

class Product(Model):
    _inherit="product"

    _fields={
        'patient_types': fields.Many2Many("clinic.patient.type","Patient Types"),
        'departments': fields.One2Many('clinic.department.product','product_id','Departments'),
        'report_visible': fields.Boolean("Report Visible"),
        'account_products': fields.One2Many('clinic.setting.account.product','product_id','Account Products'),
        'default_qty': fields.Float("Default Qty"),
        'mdc_name': fields.Char("Medical Name"),
    }

    #TODO
    def copy_master(self,ids,context={}):
        obj=self.browse(ids)[0]
        master_code=obj.code.split("-")[0]
        dom=[
            ['code','=',master_code]
        ]
        res=self.search(dom)
        if res:
            raise Exception("Master product is already exist")
        vals={
            'code': master_code,
            'name': obj.name.split("-")[0],
            'description': obj.description,
            'categ_id': obj.categ_id and obj.categ_id.id,
        }
        new_id=self.create(vals)
        return {
            'next': {
                'name': 'product',
                'mode': 'form',
                'active_id': new_id,
            },
            'flash': "Copy master product successfull",
        }


Product.register()
